searchNodes=[{"doc":"A behaviour module for implementing websocket clients. Example defmodule WS do use MintWebsocketClient def start_link ( url , opts \\ [ ] ) do opts = opts |&gt; Keyword . put_new ( :name , __MODULE__ ) |&gt; Keyword . put_new ( :protocols , [ :http1 ] ) MintWebsocketClient . start_link ( url , __MODULE__ , opts ) end @impl true def handle_connect ( status_map , state ) do # subscribe message = ~s|{&quot;action&quot;: &quot;subscribe&quot;}| { :reply , { :text , message } , state } end @impl true def handle_disconnect ( reason , state ) do # notify about disconnect { :reconnect , state } end @impl true def handle_frame ( frame , state ) do # do handle frame { :ok , state } end @impl true def terminate ( reason , _state ) do # do some cleanup if necessary end end We leave all the hussle of opening/closing/reconnecting details to the MintWebsocketClient behaviour and focus only on the callback implementation. We can now use the MintWebsocketClient API to interact with the remote websocket service. # Start the process { :ok , pid } = WS . start_link ( &quot;wss://feed.exchange.com/&quot; ) # Sends :ping frame to the server MintWebsocketClient . send_frame ( pid , :ping ) #=&gt; :ok # Casts request to the WS process MintWebsocketClient . cast ( pid , { :send_message , &quot;elixir&quot; } ) #=&gt; :ok use Websocket When you use MintWebsocketClient , the MintWebsocketClient module will set @behaviour MintWebsocketClient and define a child_spec/1 function, so your module can be used as a child in a supervision tree.","ref":"MintWebsocketClient.html","title":"MintWebsocketClient","type":"behaviour"},{"doc":"Casts request to the underlying process.","ref":"MintWebsocketClient.html#cast/2","title":"MintWebsocketClient.cast/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"MintWebsocketClient.html#child_spec/1","title":"MintWebsocketClient.child_spec/1","type":"function"},{"doc":"Invoked to handle asynchronous cast/2 messages. Returning {:ok, new_state} continues the loop with new state new_state . Returning {:reply, frame, new_state} sends the websocket frame to the server and continues the loop with new state new_state . Returning {:close, frame, new_state} tries to close the connection gracefully sending websocket frame and waiting 5 seconds before actually close connection and continues the loop with new state new_state . Returning {:close, new_state} close the connection immediately and continues the loop with new state new_state . This callback is optional. If one is not implemented, the default implementation will return {:ok, new_state} .","ref":"MintWebsocketClient.html#c:handle_cast/2","title":"MintWebsocketClient.handle_cast/2","type":"callback"},{"doc":"Invoked once the new ws connection established. Returning {:ok, new_state} continues the loop with new state new_state . Returning {:reply, frame, new_state} sends the websocket frame to the server and continues the loop with new state new_state .","ref":"MintWebsocketClient.html#c:handle_connect/2","title":"MintWebsocketClient.handle_connect/2","type":"callback"},{"doc":"Invoked once the ws connection lost. Returning {:ok, new_state} continues the loop with new state new_state . Returning {:reconnect, timeout, new_state} does reconnect to the server after specific timeout and continues the loop with new state new_state . Returning {:reconnect, new_state} does reconnect to the server immediately and continues the loop with new state new_state .","ref":"MintWebsocketClient.html#c:handle_disconnect/2","title":"MintWebsocketClient.handle_disconnect/2","type":"callback"},{"doc":"Invoked once the new websocket frame received. Returning {:ok, new_state} continues the loop with new state new_state . Returning {:reply, frame, new_state} sends the websocket frame to the server and continues the loop with new state new_state .","ref":"MintWebsocketClient.html#c:handle_frame/2","title":"MintWebsocketClient.handle_frame/2","type":"callback"},{"doc":"Invoked to handle all other messages. Return values are the same as handle_cast/2 . This callback is optional. If one is not implemented, the default implementation will return {:ok, new_state} .","ref":"MintWebsocketClient.html#c:handle_info/2","title":"MintWebsocketClient.handle_info/2","type":"callback"},{"doc":"Invoked in process init. Good place to initialize state and setup process flags. This callback is optional. If one is not implemented, the default implementation will return {:ok, nil} .","ref":"MintWebsocketClient.html#c:init/1","title":"MintWebsocketClient.init/1","type":"callback"},{"doc":"Sends frame to the websocket server.","ref":"MintWebsocketClient.html#send_frame/2","title":"MintWebsocketClient.send_frame/2","type":"function"},{"doc":"Starts the MintWebsocketClient process linked to the current process. Options :name - used for name registration All available options see Mint.HTTP.connect/4 .","ref":"MintWebsocketClient.html#start_link/3","title":"MintWebsocketClient.start_link/3","type":"function"},{"doc":"Invoked when the server is about to exit. It should do any cleanup required. This callback is optional.","ref":"MintWebsocketClient.html#c:terminate/2","title":"MintWebsocketClient.terminate/2","type":"callback"},{"doc":"MintWebsocketClient is a behaviour on top of GenServer providing convenient interface to build websocket clients. Using Mint and Mint.WebSocket under the hood.","ref":"readme.html","title":"MintWebsocketClient","type":"extras"},{"doc":"Add mint_websocket_client to your list of dependencies in mix.exs : def deps do [ { :mint_websocket_client , &quot;~&gt; 0.1.1&quot; } ] end Next, run mix deps.get in your shell to fetch and compile MintWebsocketClient . Start an interactive Elixir shell with iex -S mix: Examples Keep in mind frame you return in {:reply, frame, state} might be lost depends on the connection state. defmodule WS do use MintWebsocketClient def start_link ( url , opts \\\\ [ ] ) do opts = opts |&gt; Keyword . put_new ( :protocols , [ :http1 ] ) |&gt; Keyword . put_new ( :transport_opts , [ verify : :verify_none ] ) MintWebsocketClient . start_link ( url , __MODULE__ , opts ) end @impl true def handle_connect ( status_map , state ) do IO . inspect ( status_map , label : &quot;handle_connect&quot; ) { :ok , state } end @impl true def handle_disconnect ( reason , state ) do IO . inspect ( reason , label : &quot;handle_disconnect&quot; ) { :reconnect , state } end @impl true def handle_frame ( frame , state ) do IO . inspect ( frame , label : &quot;handle_frame&quot; ) { :ok , state } end @impl true def terminate ( reason , _state ) do IO . inspect ( reason , label : &quot;terminate&quot; ) end end iex(1)&gt; { :ok , pid } = WS . start_link ( &quot;wss://ws.postman-echo.com/raw&quot; ) { :ok , # PID &lt; 0 . 207 . 0 &gt; } handle_connect : %{ headers : [ ... ] , status : 101 } iex(2)&gt; MintWebsocketClient . send_frame ( pid , :ping ) :ok handle_frame : { :pong , &quot;&quot; } iex(3)&gt; MintWebsocketClient . send_frame ( pid , :close ) :ok handle_disconnect : % Mint.TransportError { reason : :closed } iex(4)&gt; MintWebsocketClient . send_frame ( pid , { :text , &quot;{ \\&quot; lang \\&quot; : \\&quot; elixir \\&quot; }&quot; } ) :ok handle_frame : { :text , &quot;{ \\&quot; lang \\&quot; : \\&quot; elixir \\&quot; }&quot; }","ref":"readme.html#usage","title":"MintWebsocketClient - Usage","type":"extras"}]